'From Squeak3.2alpha of 8 October 2001 [latest update: #4584] on 4 December 2002 at 9:36:26 am'!
TestCase subclass: #TestFileDirectory
	instanceVariableNames: 'shortName shortFileName longName longFileName '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SUnit-Tests'!

!TestFileDirectory methodsFor: 'running' stamp: 'mir 12/6/2001 18:53'!
testCreateDirectory	
	| dir |
	dir _ self createDirectoryCalled: self shortName in: FileDirectory default.
	self assert: dir notNil.
	self should: [self createDirectoryCalled: self shortName in: FileDirectory default] raise: Error.

	self assert: (self createDirectoryCalled: self longName in: dir) notNil.
	self should: [self createDirectoryCalled: self longName in: dir] raise: Error.
! !

!TestFileDirectory methodsFor: 'running' stamp: 'mir 12/6/2001 16:54'!
testCreateDirectoryAndSubDirStats
	|   longDir a |
	
	a _ self createDirectoryCalled: self shortName in: FileDirectory default.
	self assert: a notNil.
	longDir _ self createDirectoryCalled: self longName in: a.
	self assert: longDir notNil.
	self should: [a directoryNames size = 1].
	self should: [a entries size = 1].
	self should: [a fileAndDirectoryNames size = 1].
	self should: [a fullNamesOfAllFilesInSubtree size = 0].
	self should: [a fileNames size = 0].
	self should: [(a statsForDirectoryTree: a pathName) = #(1 0 0)].
	
! !

!TestFileDirectory methodsFor: 'running' stamp: 'mir 12/6/2001 16:57'!
testCreateDirectoryAndSubFileDirStats
	|  a file longDir |
	
	a _ self createDirectoryCalled: self shortName in: FileDirectory default.
	self assert: a notNil.
	file _ a newFileNamed: self shortFileName.
	self assert: file notNil.
	longDir _ self createDirectoryCalled: self longName in: a.
	self assert: longDir notNil.
	self should: [a directoryNames size = 1].
	self should: [a entries size = 2].
	self should: [a fileAndDirectoryNames size = 2].
	self should: [a fullNamesOfAllFilesInSubtree size = 1].
	self should: [a fileNames size = 1].
	self should: [(a statsForDirectoryTree: a pathName) = #(1 1 0)].
	file nextPut: $1.
	file flush.
	file close.
	self should: [(a statsForDirectoryTree: a pathName) = #(1 1 1)].
	
! !

!TestFileDirectory methodsFor: 'running' stamp: 'mir 12/6/2001 16:56'!
testCreateDirectoryAndSubFileStats
	|  a file |
	
	a _ self createDirectoryCalled: self shortName in: FileDirectory default.
	self assert: a notNil.
	file _ a newFileNamed: self shortFileName.
	self assert: file notNil.
	self should: [a directoryNames size = 0].
	self should: [a entries size = 1].
	self should: [a fileAndDirectoryNames size = 1].
	self should: [a fullNamesOfAllFilesInSubtree size = 1].
	self should: [a fileNames size = 1].
	self should: [(a statsForDirectoryTree: a pathName) = #(0 1 0)].
	file close.
	
! !

!TestFileDirectory methodsFor: 'running' stamp: 'mir 12/6/2001 16:57'!
testDeleteDirectory	
	self subDeleteDirectories: self shortName.
	self subDeleteDirectories: self longName.

	
! !

!TestFileDirectory methodsFor: 'running' stamp: 'mir 12/6/2001 16:58'!
testFileCreate	
	self subFileCreate: self shortFileName.
	self deleteDirectoryAAndLongA.
	self subFileCreate: self longFileName.		

! !

!TestFileDirectory methodsFor: 'running' stamp: 'mir 12/6/2001 16:54'!
testFileCreateReadOnly
	| shortDir file |
	
	shortDir _ self createDirectoryCalled: self shortName in: FileDirectory default.
	file _ shortDir newFileNamed: self shortFileName.
	file close.
	file _ shortDir readOnlyFileNamed: self shortFileName.
	self should: [file nextPut: $a.] raise: Error.
	file close.
	self should: [file closed].
	shortDir deleteFileNamed: self shortFileName ifAbsent: [self assert: false].

! !

!TestFileDirectory methodsFor: 'running' stamp: 'mir 12/6/2001 16:56'!
testFileDelete
	| shortDir file |
	
	shortDir _ self createDirectoryCalled: self shortName in: FileDirectory default.
	file _ shortDir newFileNamed: self shortFileName.
	self should: [shortDir deleteFileNamed: self shortFileName ifAbsent: [self error: 'foo']] raise: Error.
	file close.
	shortDir deleteFileNamed: self shortFileName ifAbsent: [self assert: false].
	self should: [shortDir deleteFileNamed: self shortFileName ifAbsent: [self error: 'foo']] raise: Error.

! !

!TestFileDirectory methodsFor: 'running' stamp: 'JMM 11/15/2001 23:13'!
testFileValueOf
	self assert: true
	"Need a test here"! !

!TestFileDirectory methodsFor: 'running' stamp: 'mir 12/6/2001 16:55'!
testMacLogic	
	|  shortDir file data |
	
	((Smalltalk getSystemAttribute: 1001) = 'Mac OS') ifFalse: [^self].
	self deleteDirectoryAAndLongA.
	shortDir _ self createDirectoryCalled: self shortName in: FileDirectory default.
	file _ shortDir newFileNamed: self shortFileName.
	data _ shortDir getMacFileTypeAndCreator: file fullName.
	self should: [data = #('TEXT' 'R*ch') or: [data = #('TEXT' 'ttxt')]].
	FileDirectory default
		setMacFileNamed: file fullName
		type: 'SOBJ'
		creator: 'FAST'.
	data _ shortDir getMacFileTypeAndCreator: file fullName.
	self should: [data = #('SOBJ' 'FAST')].
	file close.
	shortDir deleteFileNamed: self shortFileName ifAbsent: [self assert: false].
	self deleteDirectoryAAndLongA

! !

!TestFileDirectory methodsFor: 'running' stamp: 'JMM 11/15/2001 15:00'!
testPrimDirectoryDelimitor
	self should: [FileDirectory activeDirectoryClass primPathNameDelimiter notNil]
	! !

!TestFileDirectory methodsFor: 'running' stamp: 'JMM 11/15/2001 21:00'!
testSecurityLogic
	self should: [SecurityManager default hasFileAccess].! !


!TestFileDirectory methodsFor: 'setup' stamp: 'JMM 11/15/2001 17:03'!
hasSetup

	^true! !

!TestFileDirectory methodsFor: 'setup' stamp: 'mir 12/7/2001 01:03'!
setUp
	| maxSize |
	shortName _ 'A'.
	shortFileName _ 'A.txt'.
	self should: [(maxSize _ FileDirectory activeDirectoryClass maxFileNameLength) > 0].
	maxSize _ FileDirectory activeDirectoryClass maxPathLength -  FileDirectory default pathName size - 4 "\A\".
	longName _ String new: maxSize withAll: $A.
	longFileName _ (String new: maxSize-4 withAll: $A),'.txt'.
	self deleteDirectoryAAndLongA.

! !

!TestFileDirectory methodsFor: 'setup' stamp: 'JMM 11/15/2001 16:47'!
tearDown
	self deleteDirectoryAAndLongA.
! !


!TestFileDirectory methodsFor: 'utility' stamp: 'JMM 11/15/2001 20:24'!
checkDirectoryCalled: a

	self should: [a directoryExists: a pathName].
	self shouldnt: [a fileExists: a pathName].
	self should: [a fileOrDirectoryExists: a pathName].
	self should: [FileDirectory activeDirectoryClass maxFileNameLength > 0].
	self should: [a directoryNames size = 0].
	self should: [a entries size = 0].
	self should: [a fileAndDirectoryNames size = 0].
	self should: [a fullNamesOfAllFilesInSubtree size = 0].
	self should: [a fileNames size = 0].
	self should: [(a statsForDirectoryTree: a pathName) = #(0 0 0)].
	self should: [a containingDirectory pathName size > 0].
	self should: [a containingDirectory includesKey: (a localNameFor: a pathName)].
	self should: [a containingDirectory directoryExists: (a localNameFor: a pathName)].
	self shouldnt: [a containingDirectory fileExists: (a localNameFor: a pathName)].
	self should: [a containingDirectory fileOrDirectoryExists: (a localNameFor: a pathName)].
	self should: [a pathName size > 0].
	self should: [a pathNameDelimiter asString size > 0].
	self should: [a pathParts size > 0].
	self should: [a slash size > 0].
	self should: [(a getMacFileTypeAndCreator: a pathName) size == 2].
	self should: [(a checkName: (a localNameFor: a pathName) fixErrors: true) = (a localNameFor: a pathName)].
	self should: [(a containingDirectory fullNameFor: (a localNameFor: a pathName)) = a pathName].
	self should: [a isLegalFileName: (a localNameFor: a pathName)].
	self should: [(a containingDirectory entryAt: (a localNameFor: a pathName)) size > 0].
	self should: [a pathNameDelimiter asString = a slash].
! !

!TestFileDirectory methodsFor: 'utility' stamp: 'JMM 11/15/2001 15:23'!
createDirectoryCalled: aName in: container
	| a |
	a _ self setupDirectory: aName in: container.
	self checkDirectoryCalled: a.
	^a
! !

!TestFileDirectory methodsFor: 'utility' stamp: 'mir 12/6/2001 16:58'!
deleteDirectoryAAndLongA
	|  targetA   |

	(FileDirectory default directoryExists: self shortName) ifFalse: [^self].
	targetA _ FileDirectory default directoryNamed: self shortName.
	targetA deleteFileNamed: self shortFileName.
	targetA deleteFileNamed: self longFileName.
	(targetA fileExists: self shortFileName) ifTrue: [self halt].	
	(targetA fileExists: self longFileName) ifTrue: [self halt].	
	(targetA directoryExists: self longName) ifFalse: 
		[FileDirectory default deleteDirectory: self shortName.
		^self].
	targetA deleteDirectory: self longName.
	FileDirectory default deleteDirectory: self shortName.
	

	! !

!TestFileDirectory methodsFor: 'utility' stamp: 'JMM 11/15/2001 20:00'!
get1024String
	^self getStringOfLength: 1024! !

!TestFileDirectory methodsFor: 'utility' stamp: 'JMM 11/15/2001 20:00'!
get64KString
	^self getStringOfLength: 64*1024! !

!TestFileDirectory methodsFor: 'utility' stamp: 'JMM 11/15/2001 20:48'!
getStringOfLength: aNumber
	^((1 to: aNumber) asArray shuffled collect: [:e | e bitAnd: 16rFF]) asByteArray.
! !

!TestFileDirectory methodsFor: 'utility' stamp: 'JMM 11/15/2001 15:22'!
setupDirectory: aName in: container
	| dir |
	dir _ container createDirectory: aName.
	dir _ dir directoryNamed: aName.
	self should: [dir pathName size >= aName size].
	"self should: [(dir localNameFor: dir pathName) = aName]."
	^dir! !

!TestFileDirectory methodsFor: 'utility' stamp: 'JMM 11/15/2001 20:44'!
subDeleteDirectories: aDirName
	| dir |
	dir _ self createDirectoryCalled: aDirName in: FileDirectory default.
	self assert: dir notNil.
	FileDirectory default deleteDirectory: aDirName.
	self should: [FileDirectory default deleteDirectory: aDirName] raise: Error.
! !

!TestFileDirectory methodsFor: 'utility' stamp: 'mir 12/6/2001 16:57'!
subFileCreate: aFileName
	| shortDir file |

	shortDir _ self createDirectoryCalled: self shortName in: FileDirectory default.
	self shouldnt: [shortDir fileExists: aFileName].	
	file _ shortDir newFileNamed: aFileName.
	self should: [shortDir fileExists: aFileName].	
	self should: [shortDir newFileNamed: aFileName] raise: Error.
	self should: [file _ shortDir forceNewFileNamed: aFileName] raise: Error.
	file close.
	file _ shortDir forceNewFileNamed: aFileName.
	file close.
	file _ shortDir fileNamed: aFileName.
	self should: [(shortDir fileNamed: aFileName) isNil].
	file close.
	file _ shortDir oldFileOrNoneNamed: file fullName.
	self should:[ file notNil].
	file close.
	file _ shortDir oldFileNamed: aFileName.
	file close.
	shortDir deleteFileNamed: aFileName ifAbsent: [self assert: false].
	file _ shortDir oldFileOrNoneNamed: file fullName.
	self should:[ file isNil].

! !


!TestFileDirectory methodsFor: 'accessing' stamp: 'mir 12/6/2001 17:07'!
longFileName
	^longFileName! !

!TestFileDirectory methodsFor: 'accessing' stamp: 'mir 12/6/2001 17:06'!
longName
	^longName! !

!TestFileDirectory methodsFor: 'accessing' stamp: 'mir 12/6/2001 17:07'!
shortFileName
	^shortFileName! !

!TestFileDirectory methodsFor: 'accessing' stamp: 'mir 12/6/2001 16:51'!
shortName
	^shortName! !
